#ifndef lint
static const char rcsid[] =
    "@(#) $Header: wall.c,v 1.9 96/10/15 01:27:22 leres Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/stat.h>

#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <utmp.h>

#include <lbl/os-proto.h>

#include "hf.h"
#include "wall.h"

void
wall(users, buf, len)
	char **users, *buf;
	int len;
{
	register char **p, *msg;
	register int fd, n, msglen;
	register FILE *uf;
	struct utmp ut;
	struct stat st;
	char line[sizeof(ut.ut_line) + 1];
	char device[64];

	uf = fopen(_PATH_UTMP, "r");
	if (uf == NULL) {
		syslog(LOG_ERR, "fopen %s: %m", _PATH_UTMP);
		exit(1);
	}
	msg = NULL;
	msglen = 0;
	while (fread((char *)&ut, sizeof(ut), 1, uf) != NULL) {
#ifdef SVR4
		if (ut.ut_type != USER_PROCESS)
			continue;
#endif
		if (ut.ut_name[0] == '\0')
			continue;
#ifdef nonuser
		if (nonuser(ut))
			continue;
#endif
		for (p = users; *p != NULL; ++p)
			if (strcmp(*p, ut.ut_name) == 0) {
				strncpy(line, ut.ut_line, sizeof(ut.ut_line));
				line[sizeof(ut.ut_line)] = '\0';
				if (strchr(line, '/') != NULL
#ifdef SVR4
				    && strncmp(line, "pts/", 4) == 0 &&
				    strchr(line + 4, '/') != NULL
#endif
				    ) {
					/* XXX this cause a syslog loop */
					syslog(LOG_AUTH | LOG_NOTICE,
					    "'/' in utmp line \"%s\"", line);
					continue;
				}
				sprintf(device, "/dev/%s", line);
				fd = open(device, O_WRONLY |
#ifdef O_NOCTTY
				    O_NOCTTY |
#endif
				    O_NONBLOCK, 0);
				if (fd < 0)
					continue;
				if (fstat(fd, &st) >= 0 &&
				    (st.st_mode & 0220) == 0220) {
					if (msg == NULL) {
						buf[len] = '\0';
						msg = hf(buf);
						msglen = strlen(msg);
					}
					n = write(fd, msg, msglen);
				}
				close(fd);
		}
	}
	(void)fclose(uf);
}
